/******************************************************************************
* MODULE     : unix_entrypoint.cpp
* DESCRIPTION: Unix entry point for Unix
* COPYRIGHT  : (C) 2024 Liza Belos
*******************************************************************************
* This software falls under the GNU general public license version 3 or later.
* It comes WITHOUT ANY WARRANTY WHATSOEVER. For details, see the file LICENSE
* in the root directory or <http://www.gnu.org/licenses/gpl-3.0.html>.
******************************************************************************/

#include "unix_entrypoint.hpp"

#include <QCoreApplication>
#include <QDebug>
#include <QDir>

void addRelativeLibraryPath(QString exeDir, QString relativepath) {
  QString path = QDir::cleanPath(exeDir + relativepath);
  qDebug() << "Adding library path: " << path;
  QCoreApplication::addLibraryPath(path);
}

int main(int argc, char** argv) {
  // use argv[0] to determine the path of the executable
  // (we can't use QCoreApplication::applicationDirPath() because it's not available yet)
  QString exedir = QDir::cleanPath(argv[0]);

  addRelativeLibraryPath(exedir, "/../Plugins");
  addRelativeLibraryPath(exedir, "/../plugins");
  addRelativeLibraryPath(exedir, "/usr/plugins");
  return texmacs_entrypoint(argc, argv);
}